/*

  Lelik's MPQ API Library. (c) Andrey lelikov, Moscow 1999.
  
  All functions below are really located in storm.dll or staredit.exe.
  This library loads staredit.exe in "server" mode, and interacts as
  "client", providing gate to call mpq-related functions.

  Prototypes for storm functions are based on storm.h by brainspin@hanmail.net

  Revision History:
  2000/01 1.04 (alelikov@mtu-net.ru)
  - Added function MpqDeleteFile

  2000/01 1.03 (alelikov@mtu-net.ru)
  - Discovered last parameter in MpqOpenArchiveForUpdate

  1999/12 1.02 (alelikov@mtu-net.ru)
  - Added constants for MOAU_MAINTAIN_LISTFILE & MAFA_REPLACE_EXISTING flags.

  1999/11 1.00 (alelikov@mtu-net.ru)
  - First version.

  This library is freeware, you can do anything you want with it but with
  one exception. If you use it in your program, you must specify this fact
  in Help|About box or in similar way. You can obtain version string using
  MpqGetVersionString call.

  THIS LIBRARY IS DISTRIBUTED "AS IS".  NO WARRANTY OF ANY KIND IS EXPRESSED
  OR IMPLIED. YOU USE AT YOUR OWN RISK. THE AUTHOR WILL NOT BE LIABLE FOR 
  DATA LOSS, DAMAGES, LOSS OF PROFITS OR ANY OTHER KIND OF LOSS WHILE USING
  OR MISUSING THIS SOFTWARE.

           Any comments or suggestions are accepted at ALelikov@mtu-net.ru .
*/

#ifndef LMPQAPI_H_INCLUDED
#define LMPQAPI_H_INCLUDED

#ifdef LMPQAPI_EXPORTS
#define LMPQAPI __declspec(dllexport)
#else
#define LMPQAPI __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

BOOL   LMPQAPI WINAPI MpqInitialize();
LPCSTR LMPQAPI WINAPI MpqGetVersionString();

//MpqOpenArchiveForUpdate flags
#define MOAU_CREATE_NEW        8
#define MOAU_OPEN_EXISTING     4
#define MOAU_MAINTAIN_LISTFILE 1 

// AddFileToArcive flags
#define MAFA_ENCRYPT          0x10000
#define MAFA_COMPRESS         0x00200
#define MAFA_REPLACE_EXISTING 0x00001 

typedef HANDLE MPQHANDLE;

// staredit
MPQHANDLE LMPQAPI WINAPI MpqOpenArchiveForUpdate(LPCSTR lpcFilename,DWORD dwFlags,DWORD dwMaximumFilesInArchive);
DWORD     LMPQAPI WINAPI MpqCloseUpdatedArchive(MPQHANDLE hMPQ,DWORD dwUnknown2);
BOOL      LMPQAPI WINAPI MpqAddFileToArcive(MPQHANDLE hMPQ,LPCSTR lpcFilePath,LPCSTR lpcArcPath,DWORD dwFlags);
BOOL      LMPQAPI WINAPI MpqDeleteFile(MPQHANDLE hMPQ,LPCSTR lpcFileName);

// storm
BOOL  LMPQAPI WINAPI MpqOpenArchive(LPCSTR lpcFilename, DWORD p2, DWORD p3, MPQHANDLE *hMPQ);
BOOL  LMPQAPI WINAPI MpqOpenFileEx(MPQHANDLE hMPQ, LPCSTR lpcFilename, DWORD dwFlags, MPQHANDLE *hFile);
DWORD LMPQAPI WINAPI MpqGetFileSize(MPQHANDLE hFile, DWORD dwFlags);
BOOL  LMPQAPI WINAPI MpqReadFile(MPQHANDLE hFile,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,LPDWORD lpNumberOfBytesRead,LPOVERLAPPED lpOverlapped);
BOOL  LMPQAPI WINAPI MpqCloseFile(MPQHANDLE hFile);
BOOL  LMPQAPI WINAPI MpqCloseArchive(MPQHANDLE hMPQ);

#ifdef __cplusplus
};  // extern "C" 
#endif

#endif
